<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- exporter-pkgconfig-module.qdoc -->
  <title>Exporter.pkgconfig QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
<li class="level2"><a href="#relevant-file-tags">Relevant File Tags</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Exporter.pkgconfig QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Exporter.pkgconfig-brief -->
<p>Provides support for generating pkg-config files. <a href="#details">More...</a></p>
<!-- @@@Exporter.pkgconfig -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsModules .</td></tr><tr><td class="memItemLeft rightAlign topAlign"> Since:</td><td class="memItemRight bottomAlign"> Qbs 1.12</td></tr></table></div><ul>
<li><a href="qml-qbsmodules-exporter-pkgconfig-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#cflagsEntry-prop">cflagsEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#conflictsEntry-prop">conflictsEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#customVariables-prop">customVariables</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#excludedDependencies-prop">excludedDependencies</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#fileName-prop">fileName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#libsEntry-prop">libsEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#libsPrivateEntry-prop">libsPrivateEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#nameEntry-prop">nameEntry</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#requiresEntry-prop">requiresEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#requiresPrivateEntry-prop">requiresPrivateEntry</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#transformFunction-prop">transformFunction</a></b></b> : var</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#urlEntry-prop">urlEntry</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-qbsmodules-exporter-pkgconfig.html#versionEntry-prop">versionEntry</a></b></b> : string</li>
</ul>
<!-- $$$Exporter.pkgconfig-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>The <code>Exporter.pkgconfig</code> module contains the properties and rules to create a <a href="https://www.freedesktop.org/wiki/Software/pkg-config">pkg-config</a> metadata (<code>.pc</code>) file for a <a href="qml-qbslanguageitems-product.html">Product</a>.</p>
<p>By default, Qbs will attempt to derive some of the <code>.pc</code> file's contents from the product's <a href="qml-qbslanguageitems-export.html">Export</a> item. This behavior can be suppressed by setting the <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> property to <code>false</code>.</p>
<a name="relevant-file-tags"></a>
<h3 id="relevant-file-tags">Relevant File Tags</h3>
<a name="filetags-exporter-pkgconfig"></a><div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Tag</th><th >Since</th><th >Description</th></tr></thead>
<tr valign="top" class="odd"><td ><code>&quot;Exporter.pkgconfig.pc&quot;</code></td><td >1.12.0</td><td >This tag is attached to the generated <code>.pc</code> file.</td></tr>
</table></div>
<!-- @@@Exporter.pkgconfig -->
<h2>Property Documentation</h2>
<!-- $$$autoDetect -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="autoDetect-prop">
<td class="tblQmlPropNode"><p>
<span class="name">autoDetect</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>If this property is enabled, then Qbs will try to derive various <code>.pc</code> file entries from the contents of the product's <a href="qml-qbslanguageitems-export.html">Export</a> item, including the dependencies declared therein. Values for these fields can still be explicitly provided via the respective properties, in which case they will be concatenated with the auto-detected ones. If an exported dependency is known to correspond to a pkg-config module (either by pulling in the <code>Exporter.pkgconfig</code> module or by appearing in the <a href="qml-qbsmodules-exporter-pkgconfig.html#requiresEntry-prop">requiresEntry</a> property), it will end up in the <code>Requires</code> field of the <code>.pc</code> file, otherwise its exported <a href="qml-qbsmodules-cpp.html">cpp</a> properties will be collected for use in the <code>Cflags</code> and <code>Libs</code> fields. The <a href="qml-qbsmodules-exporter-pkgconfig.html#excludedDependencies-prop">excludedDependencies</a> property can be used to ignore specific products altogether.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@autoDetect -->
<br/>
<!-- $$$cflagsEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="cflagsEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">cflagsEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Cflags</code> field in the <code>.pc</code> file.</p>
<p>If <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, then this value will be appended to the flags derived from the product's <a href="qml-qbslanguageitems-export.html">Export</a> item and the dependencies declared therein.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@cflagsEntry -->
<br/>
<!-- $$$conflictsEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="conflictsEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">conflictsEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Conflicts</code> field in the <code>.pc</code> file.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@conflictsEntry -->
<br/>
<!-- $$$customVariables -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="customVariables-prop">
<td class="tblQmlPropNode"><p>
<span class="name">customVariables</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Use this property to add arbitrary variable assignments into the <code>.pc</code> file. The property is a map that will produce one assignment per entry. The keys and values of the map represent the left-hand sides and right-hand sides of these assignments, respectively. The values are strings that will be written into the file verbatim.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@customVariables -->
<br/>
<!-- $$$excludedDependencies -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="excludedDependencies-prop">
<td class="tblQmlPropNode"><p>
<span class="name">excludedDependencies</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>If <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, the entries of this property will be matched against the product's exported dependencies. In case such a dependency's name is present in the array, Qbs will not traverse that dependency to collect entries for the <code>Cflags</code>, <code>Libs</code>, <code>Requires</code> and <code>Requires.private</code> fields.</p>
<p>This list must not contain any values that are present in <a href="qml-qbsmodules-exporter-pkgconfig.html#requiresEntry-prop">requiresEntry</a>.</p>
<p>Default: <code>undefined</code></p>
</div></div><!-- @@@excludedDependencies -->
<br/>
<!-- $$$fileName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="fileName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">fileName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The file name of the generated pkg-config metadata file.</p>
<p>Default: <code>product.targetName + &quot;.pc&quot;</code></p>
</div></div><!-- @@@fileName -->
<br/>
<!-- $$$libsEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="libsEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">libsEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Libs</code> field in the <code>.pc</code> file.</p>
<p>If <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, then this value will be appended to the flags derived from the product's <a href="qml-qbslanguageitems-export.html">Export</a> item and the dependencies declared therein.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@libsEntry -->
<br/>
<!-- $$$libsPrivateEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="libsPrivateEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">libsPrivateEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Libs.Private</code> field in the <code>.pc</code> file.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@libsPrivateEntry -->
<br/>
<!-- $$$nameEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="nameEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">nameEntry</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Name</code> field in the <code>.pc</code> file.</p>
<p>Default: <code>product.name</code></p>
</div></div><!-- @@@nameEntry -->
<br/>
<!-- $$$requiresEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="requiresEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">requiresEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Requires</code> field in the <code>.pc</code> file.</p>
<p>If <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, then those of the product's exported dependencies that pull in the <code>Exporter.pkgconfig</code> module will also end up in the <code>Requires</code> field, provided they are not listed in <a href="qml-qbsmodules-exporter-pkgconfig.html#excludedDependencies-prop">excludedDependencies</a>.</p>
<p>If an exported dependency matches an entry of this array, Qbs will not traverse that dependency to gather <a href="qml-qbsmodules-cpp.html">cpp</a> properties for use in the <a href="qml-qbsmodules-exporter-pkgconfig.html#cflagsEntry-prop">cflagsEntry</a> and <a href="qml-qbsmodules-exporter-pkgconfig.html#libsEntry-prop">libsEntry</a> values, as pkg-config takes care of that itself.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@requiresEntry -->
<br/>
<!-- $$$requiresPrivateEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="requiresPrivateEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">requiresPrivateEntry</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Requires.private</code> field in the <code>.pc</code> file.</p>
<p>If <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, then those of the product's non-exported dependencies that pull in the <code>Exporter.pkgconfig</code> module will also end up in the <code>Requires.private</code> field, provided they are not listed in <a href="qml-qbsmodules-exporter-pkgconfig.html#excludedDependencies-prop">excludedDependencies</a>.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@requiresPrivateEntry -->
<br/>
<!-- $$$transformFunction -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="transformFunction-prop">
<td class="tblQmlPropNode"><p>
<span class="name">transformFunction</span> : <span class="type">var</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A function with the signature <code>function(product, moduleName, propertyName, value)</code>. This can be useful to &quot;fine-tune&quot; property values if <a href="qml-qbsmodules-exporter-pkgconfig.html#autoDetect-prop">autoDetect</a> is enabled, in case they need amending for the purpose of pkg-config. The <code>product</code> parameter represents the exporting product, the remaining parameters describe the module property. The modified value of the module property shall be returned.</p>
<p>Default: <code>undefined</code></p>
</div></div><!-- @@@transformFunction -->
<br/>
<!-- $$$urlEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="urlEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">urlEntry</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>URL</code> field in the <code>.pc</code> file.</p>
<p>Default: <code>undefined</code></p>
</div></div><!-- @@@urlEntry -->
<br/>
<!-- $$$versionEntry -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="versionEntry-prop">
<td class="tblQmlPropNode"><p>
<span class="name">versionEntry</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The value of the <code>Version</code> field in the <code>.pc</code> file.</p>
<p>Default: <code>product.version</code></p>
</div></div><!-- @@@versionEntry -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
